import { Engine } from "@babylonjs/core/Engines/engine";
import { AssetsManager } from "@babylonjs/core/Misc/assetsManager";
import { Scene } from "@babylonjs/core/scene";
import { AdvancedDynamicTexture } from "@babylonjs/gui/2D/advancedDynamicTexture";
import "@babylonjs/gui/2D/controls"

export class Hud {
    engine: Engine
    scene: Scene
    assetsManager: AssetsManager

    adt: AdvancedDynamicTexture

    constructor(engine: Engine, scene: Scene, assetsManager: AssetsManager) {
        this.engine = engine
        this.scene = scene
        this.assetsManager = assetsManager

        const hud = this

        const jsonTask = assetsManager.addTextFileTask("hud", "assets/gui/HUD.json")
        jsonTask.onSuccess = () => {
            const json = JSON.parse(jsonTask.text)
            this.adt.parseSerializedObject(json)
        }

        this.adt = AdvancedDynamicTexture.CreateFullscreenUI('HUD')
    }
}